/* $XConsortium: CMSObject.c,v 1.5 92/08/26 16:06:41 dave Exp $ */

/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include "CMSObjectP.h"
#include <X11/Xcms.h>

#define offset(field) XtOffsetOf(CMSObjectRec, field)
static XtResource resources[] = {
        {XtNcallback, XtCCallback, XtRCallback, sizeof(XtPointer),
         offset(cms.callbacks),	XtRCallback, (XtPointer)NULL},
/*        {XtNcmsColor,  XtCCmsColor, XtRCmsColor, sizeof(XcmsCIEXYZ *), */
        {XtNcmsColor,  XtCCmsColor, XtRCmsColor, sizeof(XtPointer), 
 	 offset(cms.color), XtRPointer, (XtPointer)NULL}
    };

static Boolean CMSObjectSetValues();

CMSObjClassRec cmsObjClassRec = {
  {
    /* superclass	  */	(WidgetClass)&objectClassRec,
    /* class_name	  */	"CMSObject",
    /* widget_size	  */	sizeof(CMSObjectRec),
    /* class_initialize   */    NULL,
    /* class_part_initialize*/	NULL,
    /* class_inited       */	FALSE,
    /* initialize	  */	NULL,
    /* initialize_hook    */	NULL,		
    /* pad                */    NULL,
    /* pad		  */    NULL,
    /* pad       	  */	0,
    /* resources	  */	resources,
    /* num_resources	  */    XtNumber(resources),
    /* xrm_class	  */	NULLQUARK,
    /* pad                */    FALSE,
    /* pad                */    FALSE,
    /* pad                */    FALSE,
    /* pad                */    FALSE,
    /* destroy		  */	NULL,
    /* pad		  */	NULL,
    /* pad		  */	NULL,
    /* set_values	  */	CMSObjectSetValues,
    /* set_values_hook    */	NULL,			
    /* pad                */    NULL,
    /* get_values_hook    */	NULL,			
    /* pad                */    NULL,
    /* version		  */	XtVersion,
    /* callback_offsets   */    NULL,
    /* pad                */    NULL,
    /* pad                */    NULL,
    /* pad                */    NULL,
    /* extension	    */  NULL
    },
  {
    /* unused */                0
    }

};

WidgetClass cmsObjClass = (WidgetClass) &cmsObjClassRec;

/*
 * Start of object routines.
 */

/*ARGSUSED*/
static Boolean CMSObjectSetValues(old, request, widget, args, num_args)
    Widget	old, request, widget;
    ArgList args;
    Cardinal *num_args;
{
  CMSObject cmsobj = (CMSObject) widget; 

                                                    /* call data */
  XtCallCallbackList(widget, cmsobj->cms.callbacks, cmsobj->cms.color);
  return False;
}

/* need to do resources */
/*??*/
