//////////////////////
//  BoundedValue.h  //
//////////////////////


#ifndef _BoundedValue_h
#define _BoundedValue_h 1 

#include <InterViews/adjust.h>
#include <InterViews/background.h>
#include <InterViews/box.h>
#include <InterViews/color.h>
#include <InterViews/display.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <IV-look/button.h>
#include <IV-look/dialogs.h>
#include <IV-X11/xdisplay.h>
#include <OS/string.h>
#include <stdio.h>
class ColorSpace;
class Valuator;

extern "C" {
#include <IV-X11/Xdefs.h>
#include <X11/Xcms.h>
#include <IV-X11/Xundefs.h>
}



class BoundedValue : public Adjustable {
public:
    BoundedValue();
    BoundedValue(Coord lower, Coord upper);         // for ConversionSpace
    BoundedValue(Coord lower, Coord upper, ColorSpace*); // for ColorSpace
    virtual ~BoundedValue();

    virtual void lower_bound(Coord);
    virtual void upper_bound(Coord);
    virtual void current_value(Coord);
    virtual void scroll_incr(Coord);
    virtual void page_incr(Coord);
    virtual Coord lower(DimensionName) const;
    virtual Coord upper(DimensionName) const;
    virtual Coord length(DimensionName) const;
    virtual Coord cur_lower(DimensionName) const;
    virtual Coord cur_upper(DimensionName) const;
    virtual Coord cur_length(DimensionName) const;

    virtual void scroll_to(DimensionName, Coord position);
    virtual void scroll_forward(DimensionName);
    virtual void scroll_backward(DimensionName);
    virtual void page_forward(DimensionName);
    virtual void page_backward(DimensionName);
    void setValuator(Valuator*, DimensionName);
    Valuator* valuator();
  protected:
    Coord curvalue_;
    Coord lower_;
    Coord span_;
    Coord scroll_incr_;
    Coord page_incr_;
    
    ColorSpace* cSpaceType;
    Valuator* myValuator;
};


#endif

