///////////////////////
//   ColorViewer.c   //
///////////////////////

#include "ColorViewer.h"


  ColorViewer::ColorViewer(ColorSpace* cs, Style* sty, Display* d) :
    Patch(nil), clSpace(cs), disp(d) {

        Style* noWarning = sty;

	(clSpace->XAdjuster())->attach(Dimension_X, this);
	(clSpace->YAdjuster())->attach(Dimension_X, this);
	(clSpace->ZAdjuster())->attach(Dimension_X, this);

	update(clSpace->XAdjuster()->observable(Dimension_X));

    }


 ColorViewer::~ColorViewer(){
     if(clSpace != nil) {
	 clSpace->XAdjuster()->detach(Dimension_X, this);
	 clSpace->YAdjuster()->detach(Dimension_X, this);
	 clSpace->ZAdjuster()->detach(Dimension_X, this);
     }
 }


void ColorViewer::allocate(Canvas* c, const Allocation& a, Extension& e) {
    e.set(c,a);
    Patch::allocate(c,a,e);
}


void ColorViewer::draw(Canvas* c, const Allocation& a) const {
    c->fill_rect(
		 a.left(), a.bottom(), a.right(), a.top(), color
		 );
}


void ColorViewer::update(Observable*) {
    Resource::unref(color);
    color = new Color(
		      clSpace->XAdjuster()->cur_lower(Dimension_X)/65535,
		      clSpace->YAdjuster()->cur_lower(Dimension_Y)/65535,
		      clSpace->ZAdjuster()->cur_lower(Dimension_Z)/65535,
		      1.0
		      );
    Resource::ref(color);
    redraw();
}



void ColorViewer::disconnect(Observable*) {
    clSpace = nil;
}
