/////////////////////////////
//   ConversionSpace.cxx   //
/////////////////////////////


#include "ConversionSpace.h"
#include "BoundedValue.h"
#include "ConvAdjuster.h"

ConversionSpace::ConversionSpace() {
    wKit = WidgetKit::instance();
}

ConversionSpace::ConversionSpace(Coord lower, Coord upper) {
    lower_ = lower;
    upper_ = upper;
    xAdjuster = new ConvAdjuster(lower, upper);
    yAdjuster = new ConvAdjuster(lower, upper);
    zAdjuster = new ConvAdjuster(lower, upper);
    wKit = WidgetKit::instance();
}


ConversionSpace::~ConversionSpace() { }



void ConversionSpace::current_value_X(Coord value) {
    xAdjuster->current_value(value);
}

void ConversionSpace::current_value_Y(Coord value) {
    yAdjuster->current_value(value);
}

void ConversionSpace::current_value_Z(Coord value) {
    zAdjuster->current_value(value);
}


Coord ConversionSpace::cur_lower_X(){
    return xAdjuster->cur_lower(Dimension_X);
}


Coord ConversionSpace::cur_lower_Y(){
    return yAdjuster->cur_lower(Dimension_X);
}


Coord ConversionSpace::cur_lower_Z(){
    return zAdjuster->cur_lower(Dimension_X);
}
