///////////////////////////
//   ConversionSpace.h   //
///////////////////////////

// ConversionSpace is a class with universal coordinates. Any ColorSpace
// can convert to and from these coordinates, its own coordinates. 
// It acts as an adjustable for all the ColorSpace's. Any change in 
// coordinates of this class call the update on all the ColorSpace's.


#ifndef _ConversionSpace_h
#define _ConversionSpace_h 1

#include <InterViews/adjust.h>
#include <InterViews/observe.h>
#include <InterViews/display.h>
#include <InterViews/patch.h>
#include <InterViews/session.h>
#include <InterViews/window.h>
#include <InterViews/layout.h>
#include <InterViews/background.h>
#include <InterViews/color.h>
#include <OS/string.h>
#include <IV-look/bevel.h>
#include <IV-look/mf_kit.h>
#include <strstream.h>

enum {FALSE, TRUE};
enum { horizontal, vertical};
typedef int Boolean;

class BoundedValue;
class ColorSpace;
class ConvAdjuster;
class ConversionSpace{
  protected:
    ConversionSpace();
  public:
    ConversionSpace(Coord lower, Coord upper);
    ~ConversionSpace();

    // set the values in the three adjustables
    virtual void current_value_X(Coord value);
    virtual void current_value_Y(Coord value);
    virtual void current_value_Z(Coord value);

    // determine the values of the three adjustables
    virtual Coord cur_lower_X();
    virtual Coord cur_lower_Y();
    virtual Coord cur_lower_Z();

    ConvAdjuster* XAdjuster(){ return xAdjuster;}
    ConvAdjuster* YAdjuster(){ return xAdjuster;}
    ConvAdjuster* ZAdjuster(){ return xAdjuster;}
  protected:
    ConvAdjuster *xAdjuster, *yAdjuster, *zAdjuster;
    Coord lower_, upper_;
    WidgetKit* wKit;
};

#endif

    
